/*
 * Created on 17-Jul-2003
 */
package protocols.bestEffortBroadcast;

import events.ProcessInitEvent;
import appia.Layer;
import appia.Session;
import appia.events.SendableEvent;
import appia.events.channel.ChannelClose;
import appia.events.channel.ChannelInit;

/**
 * Layer of the Best Effort Broadcast protocol. 
 * @author nuno
 */
public class BEBLayer extends Layer {

	public BEBLayer(){
		/* events that the protocol will create */
		evProvide = new Class[0];
	
		/* events that the protocol require to work.
		 * This is a subset of the accepted events */
		evRequire = new Class[3];
		evRequire[0] = SendableEvent.class;
		evRequire[1] = ChannelInit.class;
		evRequire[2] = ProcessInitEvent.class;
		
		/* events that the protocol will accept */
		evAccept = new Class[4];
		evAccept[0] = SendableEvent.class;
		evAccept[1] = ChannelInit.class;
		evAccept[2] = ChannelClose.class;
		evAccept[3] = ProcessInitEvent.class;
		
	}

	/**
	 * Creates a new session to this protocol.
	 * @see appia.Layer#createSession()
	 */
	public Session createSession() {
		return new BEBSession(this);
	}

}
