/*
 * Created on 21-Jul-2003
 */
package protocols.sampleAppl;

import protocols.perfectFailureDetector.PFDStartEvent;
import events.ProcessInitEvent;
import events.SampleSendableEvent;
import appia.Layer;
import appia.Session;
import appia.events.channel.ChannelClose;
import appia.events.channel.ChannelInit;
import appia.protocols.common.RegisterSocketEvent;

/**
 * Layer of the application protocol.
 * @author nuno
 */
public class SampleApplLayer extends Layer {

	public SampleApplLayer(){
		/* events that the protocol will create */
		evProvide = new Class[4];
		evProvide[0] = SampleSendableEvent.class;
		evProvide[1] = ProcessInitEvent.class;
		evProvide[2] = RegisterSocketEvent.class;
		evProvide[3] = PFDStartEvent.class;
	
		/* events that the protocol require to work.
		 * This is a subset of the accepted events */
		evRequire = new Class[1];
		evRequire[0] = ChannelInit.class;
		
	
		/* events that the protocol will accept */
		evAccept = new Class[4];
		evAccept[0] = SampleSendableEvent.class;
		evAccept[1] = ChannelInit.class;
		evAccept[2] = ChannelClose.class;
		evAccept[3] = RegisterSocketEvent.class;
		
	}

	/**
	 * Creates a new session to this protocol.
	 * @see appia.Layer#createSession()
	 */
	public Session createSession() {
		return new SampleApplSession(this);
	}

}
