/*
 * MessageEntry.java
 * Created on 22-Sep-2003, 12:34:58
 */
package protocols.utils;

import appia.events.SendableEvent;

/**
 * Class MessageEntry. This class holds some information needed by the protocols.
 * Is used as element of lists.
 * @author nuno
 */
public class MessageEntry {
	// the event
	public SendableEvent event;
	// an array of acks
	public boolean[] acks;
	// a message header
	public MessageID messageID;
	
	public MessageEntry(SendableEvent e, MessageID id, int procSize){
		event = e;
		messageID = id;
		acks = new boolean[procSize];
		for(int i=0; i<procSize; i++)
			acks[i] = false;
	}
}
