/*
 * Created on 18-Jul-2003
 *
 */
package utils;

import appia.protocols.common.InetWithPort;

/**
 * represents a process in the system.
 * @author nuno
 */
public class SampleProcess {

	private InetWithPort inetWithPort;
	private int processNumber;
	private boolean self, correct, initialized;
	
	public SampleProcess(InetWithPort inetWithPort, int proc, boolean self){
		this.inetWithPort = inetWithPort;
		this.processNumber = proc;
		this.self = self;
		correct = true;
		initialized = false;
	}

	/**
	 * @return
	 */
	public InetWithPort getInetWithPort() {
		return inetWithPort;
	}

	/**
	 * @return
	 */
	public int getProcessNumber() {
		return processNumber;
	}

	/**
	 * @return
	 */
	public boolean isSelf() {
		return self;
	}

	/**
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	public boolean equals(Object test) {
		if(!(test instanceof SampleProcess))
			return false;
		SampleProcess proc = (SampleProcess) test;
		return inetWithPort.equals(proc.inetWithPort) &&
			(processNumber == proc.processNumber) &&
			(self == proc.self);
	}

	/**
	 * @return
	 */
	public boolean isCorrect() {
		return correct;
	}

	/**
	 * @param b
	 */
	public void setCorrect(boolean b) {
		correct = b;
	}

	/**
	 * @return
	 */
	public boolean isInitialized() {
		return initialized;
	}

	/**
	 * @param initialized
	 */
	public void setInitialized(boolean initialized) {
		this.initialized = initialized;
	}

	public SampleProcess cloneProcess(){
		SampleProcess p = new SampleProcess(inetWithPort,processNumber,self);
		p.correct = correct;
		p.initialized = initialized;
		return p;
	}

}
